<template>
  <div class="row justify--center">
    <div class="flex md4">
      <va-inner-loading :loading="isLoading">
        <va-alert
          color="warning"
          border="left"
          border-color="danger"
          v-model="isError"
          class="mb-4"
          closeable
        >
          Произошла ошибка попробуйте снова!
        </va-alert>
        <h4 class="display-4 mb-4">LeadHit</h4>
        <va-form tag="form" @submit.prevent="handleSubmit">
          <va-input
            class="mb-4"
            :error="errorInput"
            label="id сайта"
            v-model.trim="idSite"
            @keydown="errorInput = false"
            error-messages="id сайта должен содержать 24 символа"
          ></va-input>
          <va-button size="medium" type="submit">Войти</va-button>
        </va-form>
      </va-inner-loading>
    </div>
  </div>
</template>
<script>
export default {
  name: "AuthView",
  data() {
    return {
      idSite: "",
      isError: false,
      errorInput: false,
      isLoading: false,
    };
  },
  methods: {
    async handleSubmit(e) {
      // 5f8475902b0be670555f1bb3
      if (this.idSite.length !== 24) return (this.errorInput = true);

      this.isLoading = true;

      const { idSite } = this;

      const res = await fetch("https://track-api.leadhit.io/client/test_auth", {
        headers: {
          "Api-Key": `${idSite}:eEZn8u05G3bzRpdL7RiHCvrYAYo`,
          "Leadhit-Site-Id": idSite,
        },
      });

      let callback;

      const data = await res.json();

      if (res.ok && data.message === "ok") {
        this.$store.commit("setSite", idSite);
        callback = () => {
          this.isLoading = false;
          this.$router.push({ name: "analytics" });
        };
      } else {
        callback = () => {
          this.isLoading = false;
          this.isError = true;
        };
      }

      return setTimeout(callback, 1000);
    },
  },
};
</script>